<?php

include("flatfile.php");

// db files//
define('pilots', 'auto_pilots.txt');
define('objects', 'alert_objects.txt');

// pilots db //
define('AP_ID', 0);
define('AP_TYPE', 1);
define('AP_NAME', 2);
define('AP_DATE', 3);
//! pilots db //

// objects db //
define('OBJ_ID', 0);
define('OBJ_OBJ', 1);
define('OBJ_TYPE', 2);
define('OBJ_INFO', 3);
define('OBJ_CRITICALITY', 4);
define('OBJ_STATUS', 5);
define('OBJ_TIME', 6);
//! objects db //

$db = new Flatfile();
$db->datadir = SANTI_SERVERPATH.'/'.SANTI_PATH.'/datas/db/';

if(isset($_POST['nd']))
	notifiers_delete(addslashes(htmlspecialchars(strip_tags(trim($_POST['nd'])))));

if(isset($_POST['oi']))
	objects_ignore(addslashes(htmlspecialchars(strip_tags(trim($_POST['oi'])))));

if(isset($_POST['oh']))
	objects_healed(addslashes(htmlspecialchars(strip_tags(trim($_POST['oh'])))));

if(isset($_POST['on']))
	objects_null(addslashes(htmlspecialchars(strip_tags(trim($_POST['on'])))));

function objects_add($obj, $type, $info, $criticality, $status)
{
	global $db;

	$new_obj[OBJ_ID] = 0;
	$new_obj[OBJ_OBJ] = $obj;
	$new_obj[OBJ_TYPE] = $type;
	$new_obj[OBJ_INFO]  = $info;
	$new_obj[OBJ_CRITICALITY]  = $criticality;
	$new_obj[OBJ_STATUS]  = $status;
	$new_obj[OBJ_TIME]  = time();

	$newId = $db->insertWithAutoId(objects, OBJ_ID, $new_obj);
}

function autopilots_add_time($autotype)
{
	global $db;

	$nt = date('d-m-Y H:i:s',time());
	$db->updateSetWhere(pilots, array(AP_DATE => $nt), new SimpleWhereClause(AP_TYPE, '=', $autotype));
}

?>